<?
 require_once($_path["include"]."errors.php");

 class Grid
 {
  function __construct($name=false, $mergeGrid=false)
  {
   $this->e=new Errors();

   if($name===false)
    $this->name="grid";
   else
    $this->name=$name;

   $this->mergeGrid=($mergeGrid?true:false);

   $this->getSetKeysGeneric=Array("start", "end");
   $this->getSetKeysSection=Array("start", "end", "before", "after");
   $this->getSetKeysEntry=Array("start", "end", "text", "tooltip", "class");

   $this->clear();
  }

  function clear()
  {
   $this->start=false;
   $this->end=false;

   $this->section=Array();
   $this->entry=Array();

   $this->sectionCurrent=false;
   $this->entryCurrent=false;
  }


  /*
   * Iteration
   * */

  function resetSection()
  {
   $this->sectionCurrent=false;
   $this->entryCurrent=false;
  }

  function resetEntry()
  {
   $this->entryCurrent=false;
  }

  function isSection($section)
  {
   if(isset($this->section[$section]))
    return true;

   return false;
  }

  function isEntry($section, $entry)
  {
   if(isset($this->entry[$section][$entry]))
    return true;

   return false;
  }

  function nextSection()
  {
   if(!($sections=array_keys($this->section)))
    return false;

   if($this->sectionCurrent===false) //first section
    $this->sectionCurrent=$sections[0];
   else //subsequence section
   {
    //loop through sections
    $l=sizeof($sections);
    for($c=0;$c<$l;$c++)
    {
     if($sections[$c]==$this->sectionCurrent) //current section found
     {
      if($c>=$l-1) //last entry
      {
       $this->sectionCurrent=false; //reset current section
      $this->entryCurrent=false; //reset current entry
       return false; //done
      }

      $this->sectionCurrent=$sections[$c+1]; //next section
      $this->entryCurrent=false; //reset current entry
      break; //done looping
     }
    }
   }

   return $this->sectionCurrent;
  }

  function nextEntry()
  {
   $section=$this->sectionCurrent;

   if(!($entries=array_keys($this->entry[$section])))
    return false;

   if($this->entryCurrent===false) //first entry
    $this->entryCurrent=$entries[0];
   else //subsequence entry
   {
    //loop through entries
    $l=sizeof($entries);
    for($c=0;$c<$l;$c++)
    {
     if($entries[$c]==$this->entryCurrent) //current entry found
     {
      if($c>=$l-1) //last entry
      {
       $this->entryCurrent=false; //reset current entry
       return false; //done
      }

      $this->entryCurrent=$entries[$c+1]; //next entry
      break; //done looping
     }
    }
   }

   return $this->entryCurrent;
  }


  /*
   * Get
   */

  function getSections()
  {
   return array_keys($this->section);
  }

  function getEntries($section=false)
  {
   if($section===false) //use current section
    $section=$this->sectionCurrent;
   else
    $this->sectionCurrent=$section;

   return array_keys($this->entry[$section]);
  }

  function _get($key, $section=false, $entry=false)
  {
   if(in_array($key, $this->getSetKeysGeneric)) //generic values
   {
    //get section/entry value
    if($section!==false)
    {
     if(!isset($this->section[$section]))
     {
      $this->e->add("Section \"".$section."\" not found", "error");
      return false;
     }

     //get entry value
     if($entry!==false)
     {
      if(!isset($this->entry[$section][$entry]))
      {
       $this->e->add("Entry \"".$entry."\" of section \"".$section."\" not found", "error");
       return false;
      }

      return $this->entry[$section][$entry][$key];
     }

     //get section value
     return $this->section[$section][$key];
    }

    //get overall value
    if($key=="start")
     return $this->start;
    else if($key=="end")
     return $this->end;
   }
   else if(in_array($key, $this->getSetKeysSection)) //section values
   {
    if($section===false) //use current section
     $section=$this->sectionCurrent;

    if(!isset($this->section[$section]))
    {
     $this->e->add("Section \"".$section."\" not found", "error");
     return false;
    }

    $this->sectionCurrent=$section;

    return $this->section[$section][$key];
   }
   else if(in_array($key, $this->getSetKeysEntry)) //entry values
   {
    if($section===false) //use current section
     $section=$this->sectionCurrent;

    if($entry===false) //use current entry
     $entry=$this->entryCurrent;

    if(!isset($this->section[$section]))
    {
     $this->e->add("Section \"".$section."\" not found", "error");
     return false;
    }

    if(!isset($this->entry[$section][$entry]))
    {
     $this->e->add("Entry \"".$entry."\" of section \"".$section."\" not found", "error");
     return false;
    }

    $this->sectionCurrent=$section;
    $this->entryCurrent=$entry;

    return $this->entry[$section][$entry][$key];
   }

   $this->e->add("Can't get value for unknown key \"".$key."\"", "error");
   return false;
  }

  function getStart($section=false, $entry=false)
  {
   return $this->_get("start", $section, $entry);
  }

  function getEnd($section=false, $entry=false)
  {
   return $this->_get("end", $section, $entry);
  }

  function getLength($section=false, $entry=false)
  {
   if(($end=$this->_get("end", $section, $entry))===false)
    return false;

   $start=$this->_get("start", $section, $entry);

   return $end-$start;
  }

  function getText($section=false, $entry=false)
  {
   return $this->_get("text", $section, $entry);
  }

  function getClass($section=false, $entry=false)
  {
   return $this->_get("class", $section, $entry);
  }

  function getTooltip($section=false, $entry=false)
  {
   return $this->_get("tooltip", $section, $entry);
  }


  /*
   * Set
   */

  function _set($key, $value, $section=false, $entry=false)
  {
   if(in_array($key, $this->getSetKeysGeneric)) //generic values
   {
    //set section / entry value
    if($section!==false)
    {
     if(!isset($this->section[$section]))
     {
      $this->e->add("Section \"".$section."\" not found", "error");
      return false;
     }

     //set entry value
     if($entry!==false)
     {
      if(!isset($this->entry[$section][$entry]))
      {
       $this->e->add("Entry \"".$entry."\" of section \"".$section."\" not found", "error");
       return false;
      }

      $this->entry[$section][$entry][$key]=$value;
      return true;
     }

     //set section value
     $this->section[$section][$key]=$value;
     return true;
    }

    //set overall value
    if($key=="start")
    {
     $this->start=$value;
     return true;
    }
    else if($key=="end")
    {
     $this->end=$value;
     return true;
    }
   }
   else if(in_array($key, $this->getSetKeysSection)) //section values
   {
    if($section===false) //use current section
     $section=$this->sectionCurrent;

    if(!isset($this->section[$section]))
    {
     $this->e->add("Section \"".$section."\" not found", "error");
     return false;
    }

    $this->sectionCurrent=$section;

    $this->section[$section][$key]=$value;
    return true;
   }
   else if(in_array($key, $this->getSetKeysEntry)) //entry values
   {
    if($section===false) //use current section
     $section=$this->sectionCurrent;

    if($entry===false) //use current entry
     $entry=$this->entryCurrent;

    if(!isset($this->section[$section]))
    {
     $this->e->add("Section \"".$section."\" not found", "error");
     return false;
    }

    if(!isset($this->entry[$section][$entry]))
    {
     $this->e->add("Entry \"".$entry."\" of section \"".$section."\" not found", "error");
     return false;
    }

    $this->sectionCurrent=$section;
    $this->entryCurrent=$entry;

    $this->entry[$section][$entry][$key]=$value;
    return true;
   }

   $this->e->add("Can't set value for unknown key \"".$key."\"", "error");
   return false;
  }


  function setSection($section=false)
  {
   if($section===false) //auto determine section
    $section=sizeof($this->section);

   if(isset($this->section[$section]))
    $this->e->add("Overwriting section \"".$section."\"", "warning");

   $this->section[$section]=Array(
    "start" => false,
    "end" => false,
    "before" => false,
    "after" => false,
   );

   $this->entry[$section]=Array();

   $this->sectionCurrent=$section;
   $this->entryCurrent=false;

   return $this->sectionCurrent;
  }

  function setEntry($text, $start=false, $end=false, $section=false, $entry=false)
  {
   if($section===false) //use current section
    $section=$this->sectionCurrent;

   if(!isset($this->section[$section]))
   {
    $this->e->add("Section \"".$section."\" not found", "error");
    return false;
   }

   if($entry===false) //auto determine entry
    $entry=sizeof($this->entry[$section]);

   if(isset($this->entry[$section][$entry]))
    $this->e->add("Overwriting entry \"".$entry."\" on section \"".$section."\"", "warning");

   if($end===false) //end not set, interpret start as length
   {
    $length=$start;
    if($this->entryCurrent!==false&&$this->entry[$section][$this->entryCurrent]["end"]!==false) //previous end set
     $start=$this->entry[$section][$this->entryCurrent]["end"]; //start is end of previous entry
    else if($this->section[$section]["start"]!==false) //section has a start position
     $start=$this->section[$section]["start"]; //start is start of section
    else if($this->start!==false) //grid has a start position
     $start=$this->start; //start is start of grid
    else //no start position
     $start=0; //assume 0 as start

    $end=$start+$length;
    unset($length);
   }
   else //start and end set
   {
    if($start>$end)
    {
     $this->e->add("Start can't be higher than end for entry \"".$entry."\" on section \"".$section."\"", "error");
     return false;
    }
   }

   $this->entry[$section][$entry]=Array(
    "text" => $text,
    "tooltip" => false,
    "class" => false,
    "start" => $start,
    "end" => $end,
   );

   //update section/overall start and end positions
   if($this->section[$section]["start"]===false||$this->section[$section]["start"]>$start)
    $this->section[$section]["start"]=$start;
   if($this->start===false||$this->start>$start)
    $this->start=$start;

   if($this->section[$section]["end"]===false||$this->section[$section]["end"]>$end)
    $this->section[$section]["end"]=$end;
   if($this->end===false||$this->end<$end)
    $this->end=$end;

   $this->sectionCurrent=$section;
   $this->entryCurrent=$entry;

   return $this->entryCurrent;
  }

  function setStart($start, $section=false, $entry=false)
  {
   return $this->_set("start", $start, $section, $entry);
  }

  function setEnd($end, $section=false, $entry=false)
  {
   return $this->_set("end", $end, $section, $entry);
  }

  function setTooltip($text, $section=false, $entry=false)
  {
   return $this->_set("tooltip", $text, $section, $entry);
  }

  function setClass($class, $section=false, $entry=false)
  {
   return $this->_set("class", $class, $section, $entry);
  }

  function setBefore($text, $section=false)
  {
   return $this->_set("before", $text, $section);
  }

  function setAfter($text, $section=false)
  {
   return $this->_set("after", $text, $section);
  }

  /*
   * Unset
   */

  function unsetSection($section)
  {
   if(!isset($this->section[$section]))
   {
    $this->e->add("Section \"".$section."\" not found", "error");
    return false;
   }

   unset($this->section[$section]);
   unset($this->entry[$section]);

   return true;
  }

  function unsetEntry($section, $entry)
  {
   if(!isset($this->section[$section]))
   {
    $this->e->add("Section \"".$section."\" not found", "error");
    return false;
   }

   if(!isset($this->entry[$section][$entry]))
   {
    $this->e->add("Entry \"".$entry."\" of section \"".$section."\" not found", "error");
    return false;
   }

   unset($this->entry[$section][$entry]);

   return true;
  }

  function unsetEntries($section)
  {
   if(!isset($this->section[$section]))
   {
    $this->e->add("Section \"".$section."\" not found", "error");
    return false;
   }

   $this->entry[$section]=Array();

   return true;
  }


  /*
   * Render
   */

  function render($type=false, $interval=false)
  {
   if($type===false)
    $type="horizontal";

   if($interval===false)
    $interval=1;

   if($type!="horizontal"&&$type!="vertical")
    $this->e->add("Unknown time table type: \"".$type."\"", "error");

   $r="";

   if($this->e->any()) //show remaining errors
    $r.=$this->e->show();

   if($this->e->any("fatal")) //stop on fatal errors
    return $r;

   //determine before/after entries
   $before=false;
   $after=false;
   foreach(array_keys($this->section) as $section)
   {
    if($this->section[$section]["before"]!==false)
     $before=true;
    if($this->section[$section]["after"]!==false)
     $after=true;

    if($before&&$after)
     break;
   }

   //determine entry width percentage
   $entryWidth=(1/($this->getLength()/$interval));

   if($before&&$after)
    $entryWidth*=($type=="horizontal"?80:90); //20% / 10% margin
   else if($before||$after)
    $entryWidth*=($type=="horizontal"?90:95); //10% / 5% margin
   else
    $entryWidth*=100; //no margin

   //prerender grid
   $oddeven=0;
   $sections=Array();
   foreach(array_keys($this->section) as $section) //loop through sections
   {
    $subsections=0;
    $sections[$section]=Array();
    foreach(array_keys($this->entry[$section]) as $entry) //loop through entry
    {
     if(!$sections[$section]) //no sections yet (first entry)
     {
      //add start section
      $sections[$section][]=Array(
       "type" => "section",
       "class" => "first",
       "close" => false,
      );
      $subsections++;

      //add before entry
      if($before)
      {
       $sections[$section][]=Array(
        "type" => "before",
        "span" => false, //set below
       );
      }

      //add grid section if entry doesn't start at begin of section
      if($this->entry[$section][$entry]["start"]!=$this->start)
      {
       $sections[$section][]=Array(
        "type" => "grid",
        "start" => $this->start,
        "end" => $this->entry[$section][$entry]["start"],
       );
      }
     }
     else //previous sections available
     {
      $previous=$sections[$section][sizeof($sections[$section])-1];

      if($this->entry[$section][$entry]["start"]<$previous["start"]||$this->entry[$section][$entry]["start"]<$previous["end"]) //starts before or within previous
      {
       //add grid section if entry doesn't end at end of section
       if($previous["end"]<$this->end)
       {
        $sections[$section][]=Array(
         "type" => "grid",
         "start" => $previous["end"],
         "end" => $this->end,
        );
       }

       //add after entry
       if($after&&$sections==1)
       {
        $sections[$section][]=Array(
         "type" => "after",
         "span" => false, //set below
        );
       }

       //continue on next section
       $sections[$section][]=Array(
        "type" => "section",
        "class" => "subsequent",
        "close" => true,
       );
       $subsections++;

       //add grid section if entry doesn't start at begin of section
       if(floor($this->entry[$section][$entry]["start"]/$interval)!=floor($this->start/$interval))
       {
        $sections[$section][]=Array(
         "type" => "grid",
         "start" => $this->start,
         "end" => $this->entry[$section][$entry]["start"],
        );
       }
      }
      else if($this->entry[$section][$entry]["start"]==$previous["end"]) //starts at end of previous
      {
       //nothing in between
      }
      else //starts after previous
      {
       $sections[$section][]=Array(
        "type" => "grid",
        "start" => $previous["end"],
        "end" => $this->entry[$section][$entry]["start"],
       );
      }
     }

     if($this->entry[$section][$entry]["start"]<$this->start) //ensure entry doesn't start before displayed start
      $start=$this->start;
     else
      $start=$this->entry[$section][$entry]["start"];

     if($this->entry[$section][$entry]["end"]>$this->end) //ensure entry doesn't end after displayed end
      $end=$this->end;
     else if((($this->entry[$section][$entry]["end"]-$this->entry[$section][$entry]["start"])/$interval)<1) //ensure entry length is at least 1
      $end=$this->entry[$section][$entry]["start"]+$interval;
     else
      $end=$this->entry[$section][$entry]["end"];

     $sections[$section][]=Array(
      "type" => "entry",
      "entry" => $entry,
      "start" => $start,
      "end" => $end,
     );
    }

    if($sections[$section])
    {
     //add grid section if entry doesn't end at end of section
     $previous=$sections[$section][sizeof($sections[$section])-1];
     if($previous["end"]<$this->end)
     {
      $sections[$section][]=Array(
       "type" => "grid",
       "start" => $previous["end"],
       "end" => $this->end,
      );
     }
    }
    else //no sections
    {
     //add before entry
     if($before)
     {
      $sections[$section][]=Array(
       "type" => "before",
       "span" => false, //set below
      );
     }

     //add grid
     $sections[$section][]=Array(
      "type" => "grid",
      "start" => $this->start,
      "end" => $this->end,
     );

     //add after entry
     if($after)
     {
      $sections[$section][]=Array(
       "type" => "after",
       "span" => false, //set below
      );
     }
    }

    unset($previous);

    //set before sections counter
    if($before)
    {
     foreach(array_keys($sections[$section]) as $key)
     {
      if($sections[$section][$key]["type"]=="before")
      {
       $sections[$section][$key]["span"]=$subsections;
       break;
      }
     }
    }

    //add after entry / set after sections counter
    if($after)
    {
     if($subsections>1) //more than 1 sections, already added above
     {
      foreach(array_keys($sections[$section]) as $key)
      {
       if($sections[$section][$key]["type"]=="after")
       {
        $sections[$section][$key]["span"]=$subsections;
        break;
       }
      }
     }
     else
     {
      $sections[$section][]=Array(
       "type" => "after",
       "span" => $subsections,
      );
     }
    }

    //overwrite class for last section
    if($subsections>1)
    {
     foreach(array_reverse(array_keys($sections[$section])) as $key)
     {
      if($sections[$section][$key]["type"]=="section")
      {
       $sections[$section][$key]["class"]="last";
       break;
      }
     }
    }
   }

   //change start/end to interval based
   foreach(array_keys($sections) as $section)
   {
    foreach(array_keys($sections[$section]) as $key)
    {
     if(isset($sections[$section][$key]["start"]))
      $sections[$section][$key]["start"]=round($sections[$section][$key]["start"]/$interval);
     if(isset($sections[$section][$key]["end"]))
      $sections[$section][$key]["end"]=round($sections[$section][$key]["end"]/$interval);
    }
   }

   //render table
   $r.="<div class=\"".$this->name."\"><table class=\"".$type."\">\n";

   if($type=="horizontal") //horizontal time table
   {
    //render sections
    foreach(array_keys($sections) as $key)
    {
     foreach($sections[$key] as $section)
     {
      switch($section["type"])
      {
       case "section":
       {
        if($section["close"])
         $r.=" </tr>\n";

        $r.=" <tr class=\"".($key==="header"||$key==="footer"?$key:"body ".$key)." ".($oddeven%2?"odd":"even")." ".$section["class"]."\">\n";

        break;
       }
       case "entry":
       {
        $length=$section["end"]-$section["start"];

        $r.="  <td class=\"".$section["type"].($this->getClass($key, $section["entry"])?" ".$this->getClass($key, $section["entry"]):"")."\" style=\"width: ".round($length*$entryWidth, 1)."%\"".($length>1?" colspan=\"".$length."\"":"").">";

        $r.=$this->getText($key, $section["entry"]); //set text

        if($tooltip=$this->getTooltip($key, $section["entry"])) //tooltip
         $r.="<div class=\"tooltip\">".$tooltip."</div>";

        $r.="</td>\n";
        break;
       }
       case "before":
       case "after":
       {
        $r.="  <td class=\"".$section["type"]."\"".($section["span"]>1?" rowspan=\"".$section["span"]."\"":"").">";

        if($section["type"]=="before")
         $r.=$this->_get("before", $key); //set text
        else
         $r.=$this->_get("after", $key); //set text


        $r.="</td>\n";
        break;
       }
       case "grid":
       {
        $length=$section["end"]-$section["start"];

        if($this->mergeGrid)
        {
         if($length>1)
          $r.="  <td class=\"".$section["type"]."\" style=\"width: ".round($entryWidth*$length, 1)."%\" colspan=\"".$length."\"></td>\n";
         else
          $r.="  <td class=\"".$section["type"]."\" style=\"width: ".round($entryWidth, 1)."%\"></td>\n";
        }
        else //render full grid
        {
         for($c=0;$c<$length;$c++)
          $r.="  <td class=\"".$section["type"]."\" style=\"width: ".round($entryWidth, 1)."%\"></td>\n";
        }

        break;
       }
      }
     }

     $r.=" </tr>\n";
     $oddeven++;
    }
   }
   else //vertical time table
   {
    $oddeven=0;
    $before=false;
    foreach(array_keys($sections) as $key)
    {
     foreach($sections[$key] as $section)
     {
      if($section["type"]=="before")
      {
       if(!$before) //first before section
       {
        $r.=" <tr class=\"".$section["type"]."\">\n"; //create section
        $before=true;
       }

       $r.="  <td class=\"".($key==="header"||$key==="footer"?$key:"body ".$key)." ".($oddeven%2?"odd":"even")."\"".($section["span"]>1?" colspan=\"".$section["span"]."\"":"").">";

       $r.=$this->_get("before", $key); //set text

       $r.="</td>\n";
      }
     }

     $oddeven++;
    }

    if($before)
    {
     $r.="  <td class=\"fake\"></td>\n";
     $r.=" </tr>\n";
    }


    $start=round($this->start/$interval);
    $end=round($this->end/$interval);
    for($c=$start;$c<$end;$c++)
    {
     $r.=" <tr>\n";

     $oddeven=0;
     foreach(array_keys($sections) as $key)
     {
      foreach($sections[$key] as $section)
      {
       switch($section["type"])
       {
        case "entry":
        {
         if($section["start"]==$c)
         {
          $length=$section["end"]-$section["start"];

          $r.="  <td class=\"".$section["type"]." ".($key==="header"||$key==="footer"?$key:"body ".$key)." ".($oddeven%2?"odd":"even").($this->getClass($key, $section["entry"])?" ".$this->getClass($key, $section["entry"]):"")."\" style=\"height: ".round($length*$entryWidth, 1)."%\"".($length>1?" rowspan=\"".$length."\"":"").">";

          $r.=$this->getText($key, $section["entry"]); //set text

          if($tooltip=$this->getTooltip($key, $section["entry"])) //tooltip
           $r.="<div class=\"tooltip\">".$tooltip."</div>";

          $r.="</td>\n";
         }
         break;
        }
        case "grid":
        {
         if($this->mergeGrid)
         {
          if($section["start"]==$c)
          {
           $length=$section["end"]-$section["start"];

           if($length>1)
            $r.="  <td class=\"".$section["type"]." ".($key==="header"||$key==="footer"?$key:"body ".$key)." ".($oddeven%2?"odd":"even")."\" style=\"height: ".round($entryWidth*$length, 1)."%\" rowspan=\"".$length."\"></td>\n";
           else
            $r.="  <td class=\"".$section["type"]." ".($key==="header"||$key==="footer"?$key:"body ".$key)." ".($oddeven%2?"odd":"even")."\" style=\"height: ".round($entryWidth, 1)."%\"></td>\n";
          }
         }
         else //render full grid
         {
          if($section["start"]<=$c&&$c<$section["end"])
           $r.="  <td class=\"".$section["type"]." ".($key==="header"||$key==="footer"?$key:"body ".$key)." ".($oddeven%2?"odd":"even")."\" style=\"height: ".round($entryWidth, 1)."%\"></td>\n";
         }

         break;
        }
       }
      }

      $oddeven++;
     }

     $r.="  <td class=\"fake\" style=\"height: ".round($entryWidth, 1)."%;\"></td>\n";
     $r.=" </tr>\n";
    }

    $oddeven=0;
    $after=false;
    foreach(array_keys($sections) as $key)
    {
     foreach($sections[$key] as $section)
     {
      if($section["type"]=="after")
      {
       if(!$after) //first after section
       {
        $r.=" <tr class=\"".$section["type"]."\">\n"; //create section
        $after=true;
       }

       $r.="  <td class=\"".($key==="header"||$key==="footer"?$key:"body ".$key)." ".($oddeven%2?"odd":"even")."\"".($section["span"]>1?" colspan=\"".$section["span"]."\"":"").">";

       $r.=$this->_get("after", $key); //set text

       $r.="</td>\n";
      }
     }

     $oddeven++;
    }

    if($after)
    {
     $r.="  <td class=\"fake\"></td>\n";
     $r.=" </tr>\n";
    }
   }

   $r.="</table></div>\n";

   return $r;
  }

 }

?>
